Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 177 by niro, Sun Jul 31 15:04:16 2005 UTC revision 3034 by niro, Fri Jun 30 12:09:53 2017 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.19 2005-07-31 15:04:16 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default user mage.rc
11  SMAGEVERSION=0.3.7-r1  : ${MAGERC="/etc/mage.rc"}
 PKGSUFFIX="mpk"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
12    
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc  source /etc/mage.rc.global
17    source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21  showversion() {  # export default path
22   echo -en "Magellan Source Install v${SMAGEVERSION} "  export PATH="${PATH}:${MLIBDIR}"
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
23    
24  xtitle() {  ## setup ##
25   if [ ${TERM} == "xterm" ]  SMAGENAME="$1"
26   then  SMAGEVERSION="$(< ${MLIBDIR}/version)"
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  #install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  #echo "DEBUG: ${MY_SRC_URI}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
 # only needed to run through a list of mirrors  
 # if [ "$?" == "0" ]  
 # then  
 # break  
 # else  
 # continue  
 # fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo ">== Checking MD5 sums:"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
   
 build_mage_script() {  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall() {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude() {  
  local i  
   
  if [ -n "$@" ]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
27    
28  setup_ccache_environment(){  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
29   if [ -x /usr/bin/ccache ]  if [[ -n ${MROOT} ]]
30   then  then
31   echo "Using CCache for compilation ..."   export PKGDIR=${MROOT}/${PKGDIR}
32   export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   export BUILDDIR=${MROOT}/${BUILDDIR}
33   #unset CC CXX   export BINDIR=${MROOT}/${BINDIR}
34   fi  fi
 }  
35    
36  # print out our version  # print out our version
37  showversion  showversion
38  echo  echo
39    
40  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
41  then  then
42   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
43   echo   echo
44   exit 1   exit 1
45  fi  fi
46    
47  #updating smage2-scripts  # load supported mage features
48  if [ "$1" == "update" ]  load_mage_features
49    
50    # updating smage2-scripts
51    if [[ $1 = update ]]
52  then  then
53   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
54   then   then
# Line 433  then Line 58  then
58   exit 0   exit 0
59  fi  fi
60    
61  #creates md5sums for smages to given dir  # creates md5sums for smages to given dir
62  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
63  then  then
64   if [ $# -ge 3 ]   if [ $# -ge 2 ]
65   then   then
66   SMAGENAME="$2"   SMAGENAME="$2"
67   MD5DIR="$3"   MD5DIR="$3"
68   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
69    
70     smagesource ${SMAGENAME} || die "download source failed"
71    
72   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
73   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 486  then Line 113  then
113   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
114   unset my_SOURCEDIR   unset my_SOURCEDIR
115   done   done
116    
117   echo   echo
118   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
119   echo   echo
120   else   else
121   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
122   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
123   echo   echo
124   echo   echo
125   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
126   echo   echo
127   exit 1   exit 1
128   fi   fi
129    
130   exit 0   exit 0
131  fi  fi
132    
133  #download sources  # download sources
134  if [ "$1" == "download" -a -n "$2" ]  if [ "$1" == "download" -a -n "$2" ]
135  then  then
136   if [ ! -d ${SMAGESCRIPTSDIR} ]   if [ ! -d ${SMAGESCRIPTSDIR} ]
# Line 514  then Line 141  then
141   # get smage   # get smage
142   SMAGENAME="$2"   SMAGENAME="$2"
143   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
144   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
145    
146   download_sources   download_sources
147   exit 0   exit 0
148  fi  fi
149    
150  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  # regen-mage-tree
151    if [ "$1" == "only-regen-tree" -a -n "$2" ]
152  then  then
153   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
154  fi   SMAGENAME="$2"
155     MD5DIR="$(dirname ${SMAGENAME})/md5"
156     smagesource ${SMAGENAME} || die "regen: smage2 not found"
157    
158  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   regen_mage_tree
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
159    
160  if [ -z "${SOURCEDIR}" ]   # build several subpackages
161  then   if [[ -n ${SPLIT_PACKAGES} ]]
162   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   then
163  fi   split_save_variables
164     for subpackage in ${SPLIT_PACKAGES}
165     do
166     # get the right variables for the split
167     export PNAME="${subpackage}"
168     split_info_${subpackage}
169     # fix PCATEGORIE -> PCAT
170     if [[ ! -z ${PCATEGORIE} ]]
171     then
172     PCAT="${PCATEGORIE}"
173     unset PCATEGORIE
174     fi
175     # build md5sum for existing packages
176     generate_package_md5sum \
177     --pcat "${PCAT}" \
178     --pname "${PNAME}" \
179     --pver "${PVER}" \
180     --pbuild "${PBUILD}" \
181     --parch "${ARCH}"
182     # restore smage environment
183     split_restore_variables
184     done
185     # unset all saved smage variables
186     split_unset_variables
187    
188  if [ -z "${SMAGESCRIPTSDIR}" ]   else
189  then   # build md5sum for existing packages
190   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   generate_package_md5sum \
191  fi   --pcat "${PCAT}" \
192     --pname "${PNAME}" \
193     --pver "${PVER}" \
194     --pbuild "${PBUILD}" \
195     --parch "${ARCH}"
196     fi
197    
198  if [ -z "${SMAGE2RSYNC}" ]   exit 0
 then  
  echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  
  exit 1  
199  fi  fi
200    
201  if [ -z "${BINDIR}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
202  then  then
203   die "no BINDIR variable found in /etc/mage.rc"   # set correct SMAGENAME
204  fi   SMAGENAME="$2"
205     MD5DIR="$(dirname ${SMAGENAME})/md5"
206    
207  if [ -z "${CHOST}" ]   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
208  then  
209   die "no CHOST variable found in /etc/mage.rc"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
210    
211     if [[ -d ${SOURCEDIR}/${PNAME} ]]
212     then
213     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
214     rm -rf ${SOURCEDIR}/${PKGNAME}
215     fi
216    
217     download_sources
218     source_pkg_build ${SMAGENAME}
219     exit 0
220  fi  fi
221    
222  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
223  then  then
224   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
225     msetfeature "srcpkgtarball"
226    
227     # abort if given file is not a source pkg
228     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
229    
230     # set correct SMAGENAME; use the one that the src_pkg provide
231     # /path/to/SOURCEDIR/PNAME/SMAGENAME
232     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
233    
234     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
235    
236     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
237    
238     # unpack srctarball
239     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
240    
241     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
242    
243     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
244  fi  fi
245    
246  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
247  then  then
248   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
249     SMAGENAME="$2"
250  fi  fi
251    
252    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
253    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
254     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
255    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
256    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
257    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
258    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
259    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
260    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
261    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
262    
263  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
264  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
265  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
266    SMAGE_LOG_CMD="tee -a ${SMAGELOGDIR}/${PKGNAME}.log"
267    
268  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
269  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
270    
271  #download sources  if mqueryfeature "srcpkgbuild"
272  download_sources  then
273     if [[ -d ${SOURCEDIR}/${PNAME} ]]
274     then
275     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
276     rm -rf ${SOURCEDIR}/${PNAME}
277     fi
278    fi
279    
280  #fixes some issues with these functions  # download sources
281    mqueryfeature "srcpkgtarball" || download_sources
282    
283    # fixes some issues with these functions
284    export -f pkg_setup || die "pkg_setup export failed"
285  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
286  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
287    export -f src_check || die "src_check export failed"
288  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
289    
290  #fixes some compile issues  # fixes some compile issues
291  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
292    export CPPFLAGS="${CPPFLAGS}" || die "CPPFLAGS export failed"
293  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
294  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
295    then
296     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
297    else
298     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
299    fi
300    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
301  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
302  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
303    
304    # setup distcc
305    # setup for distcc goes *before* ccache, so ccache comes before distcc in path
306    mqueryfeature "distcc" && setup_distcc_environment
307    
308    # setup icecc
309    # setup for icecc goes *before* ccache, so ccache comes before icecc in path
310    mqueryfeature "icecc" && setup_icecc_environment
311    
312  #setup distcc  # setup ccache
313  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  mqueryfeature "ccache" && setup_ccache_environment
314  if [ "${SMAGE_USE_DISTCC}" == "true" ]  
315    if mqueryfeature "resume"
316  then  then
317   setup_distcc_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
318    
319     # setup build logging
320     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
321     if [[ -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2 ]]
322     then
323     bunzip2 -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2
324     fi
325     echo -e "### Resume started on $(date) ###\n" >> ${SMAGELOGDIR}/${PKGNAME}.log
326    
327    else
328     # clean up builddir if a previously one exist
329     if [ -d ${BUILDDIR} ]
330     then
331     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
332     fi
333     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
334    
335     # clean up srcdir if a previously unpacked one exist
336     if [ -d ${SRCDIR} ]
337     then
338     rm -rf ${SRCDIR}
339     fi
340    
341     # clean up bindir if a previous build exist or create a new one
342     if [ -d ${BINDIR} ]
343     then
344     rm -rf ${BINDIR}
345     fi
346     install -d ${BINDIR} || die "couldn't create \$BINDIR."
347    
348     # clean up package temp dir if a previous build exist
349     if [ -d ${BUILDDIR}/${PKGNAME} ]
350     then
351     rm -rf ${BUILDDIR}/${PKGNAME}
352     fi
353    
354     # clean up stamps dir
355     if [ -d ${BUILDDIR}/.stamps ]
356     then
357     rm -rf ${BUILDDIR}/.stamps
358     fi
359    
360     # setup build logging
361     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
362     echo -e "### Build started on $(date) ###\n" > ${SMAGELOGDIR}/${PKGNAME}.log
363  fi  fi
364    
365  #setup ccache  if [[ ${PKGTYPE} = virtual ]]
 if [ "${SMAGE_USE_CCACHE}" == "true" ]  
366  then  then
367   setup_ccache_environment   echo "virtual package detected; nothing will be build ..."
368  fi   # automatically set !pkgbuild here too
369     msetfeature "!pkgbuild"
370    else
371     ( run_resume pkg_setup || pkg_setup ) |& ${SMAGE_LOG_CMD}
372     die_pipestatus 0 "pkg_setup failed"
373     resume_stamp pkg_setup
374     step_by_step pkg_setup
375    
376     ( run_resume src_prepare || src_prepare ) |& ${SMAGE_LOG_CMD}
377     die_pipestatus 0 "src_prepare failed"
378     resume_stamp src_prepare
379     step_by_step src_prepare
380    
381  # small sleep to show our settings   ( run_resume src_compile || src_compile ) |& ${SMAGE_LOG_CMD}
382  sleep 1   die_pipestatus 0 "src_compile failed"
383     resume_stamp src_compile
384     step_by_step src_compile
385    
386  #debug   # only run checks if requested
387  #echo "CC=${CC}"   if mqueryfeature "!check"
388  #echo "CXX=${CXX}"   then
389  #echo "DISTCC_DIR=${DISTCC_DIR}"   echo "!check detected; src_check() will not be run!" |& ${SMAGE_LOG_CMD}
390  #echo "PATH: ${PATH}"   else
391  #echo "--------------------------------------"   ( run_resume src_check || src_check ) |& ${SMAGE_LOG_CMD}
392  #env   die_pipestatus 0 "src_check failed"
393  #echo "--------------------------------------"   resume_stamp src_check
394  #read   fi
395  #debug end   step_by_step src_check
396    
397     # build several subpackages
398     if [[ -n ${SPLIT_PACKAGES} ]]
399     then
400     # save bindir & pname
401     split_save_variables
402     export SAVED_BINDIR="${BINDIR}"
403     for subpackage in ${SPLIT_PACKAGES}
404     do
405     split_info_${subpackage}
406     if [[ ${PKGTYPE} = virtual ]]
407     then
408     echo
409     echo -en "${COLBLUE}*** ${COLDEFAULT}"
410     echo -en "Virtual package detected"
411     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
412     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
413    
414     echo "virtual package detected; nothing will be build ..."
415     # automatically set !pkgbuild here too
416     msetfeature "!pkgbuild"
417     else
418     if typeset -f src_install_${subpackage} > /dev/null
419     then
420     # export subpackage bindir
421     export BINDIR="${SAVED_BINDIR}_${subpackage}"
422     # export PNAME, several internal function and include
423     # rely on this variable
424     export PNAME="${subpackage}"
425    
426     echo
427     echo -en "${COLBLUE}*** ${COLDEFAULT}"
428     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
429     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
430     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
431    
432     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) |& ${SMAGE_LOG_CMD}
433     die_pipestatus 0 "src_install_${subpackage} failed"
434     resume_stamp src_install_${subpackage}
435     step_by_step src_install_${subpackage}
436     fi
437     fi
438     # restore smage environment
439     split_restore_variables
440     done
441     # unset all saved smage variables
442     split_unset_variables
443     else
444     ( run_resume src_install || src_install ) |& ${SMAGE_LOG_CMD}
445     die_pipestatus 0 "src_install failed"
446     resume_stamp src_install
447     step_by_step src_install
448     fi
449    fi
450    
451  #cleans up build if a previously one exists  # echo for sake of good-looking
452  if [ -d ${BUILDDIR} ]  echo
453    
454    if mqueryfeature "!compressdoc"
455  then  then
456   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo -e "!compressdoc detected; documentation will not be compressed ..."
457    elif mqueryfeature "!pkgbuild"
458    then
459     echo "!pkgbuild detected; skipping documentation compression..."
460    else
461     # compressing doc, info & man files
462     if [[ -n ${SPLIT_PACKAGES} ]]
463     then
464     # save smage environment
465     split_save_variables
466     for subpackage in ${SPLIT_PACKAGES}
467     do
468     # honor split_info
469     split_info_${subpackage}
470     if [[ ${PKGTYPE} = virtual ]]
471     then
472     # automatically set !pkgbuild here too
473     msetfeature "!pkgbuild"
474     fi
475    
476     if mqueryfeature "!compressdoc"
477     then
478     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
479     elif mqueryfeature "!pkgbuild"
480     then
481     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
482     else
483     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
484     resume_stamp post-mcompressdoc_${subpackage}
485     fi
486     # restore smage environment
487     split_restore_variables
488     done
489     # unset saved variables
490     split_unset_variables
491     else
492     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
493     resume_stamp post-mcompressdoc
494     fi
495  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
496    
497  #cleans up srcdir if a previously unpacked one exists  if mqueryfeature "!libtool"
 if [ -d ${SRCDIR} ]  
498  then  then
499   rm -rf ${SRCDIR}   if mqueryfeature "!pkgbuild"
500     then
501     echo "!pkgbuild detected; skipping libtool archive stripping ..."
502     else
503     if [[ -n ${SPLIT_PACKAGES} ]]
504     then
505     # save smage environment
506     split_save_variables
507     for subpackage in ${SPLIT_PACKAGES}
508     do
509     # honor split_info
510     split_info_${subpackage}
511     if [[ ${PKGTYPE} = virtual ]]
512     then
513     # automatically set !pkgbuild here too
514     msetfeature "!pkgbuild"
515     fi
516    
517     if mqueryfeature "!libtool"
518     then
519     if mqueryfeature "!pkgbuild"
520     then
521     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
522     else
523     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
524     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
525     resume_stamp post-mstriplibtoolarchive_${subpackage}
526     fi
527     fi
528    
529     # restore smage environment
530     split_restore_variables
531     done
532     # unset saved variables
533     split_unset_variables
534     else
535     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
536     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
537     resume_stamp post-mstriplibtoolarchive
538     fi
539     fi
540  fi  fi
541    
542  #cleans up bindir if a previous build exists or creates a new one  if mqueryfeature "purge"
 if [ -d ${BINDIR} ]  
543  then  then
544   rm -rf ${BINDIR}   if mqueryfeature "!pkgbuild"
545     then
546     echo "!pkgbuild detected; skipping file purgation ..."
547     else
548     if [[ -n ${SPLIT_PACKAGES} ]]
549     then
550     # save smage environment
551     split_save_variables
552     for subpackage in ${SPLIT_PACKAGES}
553     do
554     # honor split_info
555     split_info_${subpackage}
556     if [[ ${PKGTYPE} = virtual ]]
557     then
558     # automatically set !pkgbuild here too
559     msetfeature "!pkgbuild"
560     fi
561    
562     if mqueryfeature "purge"
563     then
564     if mqueryfeature "!pkgbuild"
565     then
566     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
567     else
568     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
569     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
570     resume_stamp post-mpurgetargets_${subpackage}
571     fi
572     fi
573    
574     # restore smage environment
575     split_restore_variables
576     done
577     # unset saved variables
578     split_unset_variables
579     else
580     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
581     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
582     resume_stamp post-mpurgetargets
583     fi
584     fi
585  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
586    
587  #cleans up package temp dir if a previous build exists  # stripping all bins and libs
588  if [ -d ${BUILDDIR}/${PKGNAME} ]  if mqueryfeature "!strip"
589    then
590     echo -e "!strip detected; package will not be stripped ..."
591    elif mqueryfeature "!pkgbuild"
592  then  then
593   rm -rf ${BUILDDIR}/${PKGNAME}   echo "!pkgbuild detected; skipping stripping of the package ..."
594    else
595     if [[ -n ${SPLIT_PACKAGES} ]]
596     then
597     # save smage environment
598     split_save_variables
599     for subpackage in ${SPLIT_PACKAGES}
600     do
601     # honor split_info
602     split_info_${subpackage}
603     if [[ ${PKGTYPE} = virtual ]]
604     then
605     # automatically set !pkgbuild here too
606     msetfeature "!pkgbuild"
607     fi
608    
609     if mqueryfeature "!strip"
610     then
611     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
612     elif mqueryfeature "!pkgbuild"
613     then
614     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
615     else
616     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
617     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
618     resume_stamp post-mstripbins_${subpackage}
619     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
620     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
621     resume_stamp post-mstriplibs_${subpackage}
622     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
623     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
624     resume_stamp post-mstripstatic_${subpackage}
625     fi
626    
627     # restore smage environment
628     split_restore_variables
629     done
630     # unset saved variables
631     split_unset_variables
632     else
633     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
634     run_resume post-mstripbins || mstripbins ${BINDIR}
635     resume_stamp post-mstripbins
636     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
637     run_resume post-mstriplibs || mstriplibs ${BINDIR}
638     resume_stamp post-mstriplibs
639     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
640     run_resume post-mstripstatic || mstripstatic ${BINDIR}
641     resume_stamp post-mstripstatic
642     fi
643  fi  fi
644    
645  #cleans up timestamp if one exists  if mqueryfeature "qalint"
 if [ -f /var/tmp/timestamp ]  
646  then  then
647   mage rmstamp   if mqueryfeature "!pkgbuild"
648  fi   then
649     echo "!pkgbuild detected; skipping QA lint checks ..."
650     else
651     if [[ -n ${SPLIT_PACKAGES} ]]
652     then
653     # save smage environment
654     split_save_variables
655     for subpackage in ${SPLIT_PACKAGES}
656     do
657     # honor split_info
658     split_info_${subpackage}
659     if [[ ${PKGTYPE} = virtual ]]
660     then
661     # automatically set !pkgbuild here too
662     msetfeature "!pkgbuild"
663     fi
664    
665  src_prepare || die "src_prepare failed"   if mqueryfeature "qalint"
666  src_compile || die "src_compile failed"   then
667  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
668     then
669     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
670     else
671     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
672     mqalint ${BINDIR}_${subpackage}
673     fi
674     fi
675    
676     # restore smage environment
677     split_restore_variables
678     done
679     # unset saved variables
680     split_unset_variables
681     else
682     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
683     mqalint ${BINDIR}
684     fi
685     fi
686    fi
687    
688  #compressing doc, info & man files  if mqueryfeature "!pkgbuild"
 echo -e "Compressing man-pages ..."  
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
689  then  then
690   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   echo -e "!pkgbuild detected; Package will not be build ..."
691    else
692     # build several subpackages
693     if [[ -n ${SPLIT_PACKAGES} ]]
694     then
695     split_save_variables
696     for subpackage in ${SPLIT_PACKAGES}
697     do
698     # get the right variables for the split
699     export PNAME="${subpackage}"
700     split_info_${PNAME}
701     # fix PCATEGORIE -> PCAT
702     if [[ ! -z ${PCATEGORIE} ]]
703     then
704     PCAT="${PCATEGORIE}"
705     unset PCATEGORIE
706     fi
707     if [[ ${PKGTYPE} = virtual ]]
708     then
709     # automatically set !pkgbuild here too
710     msetfeature "!pkgbuild"
711     fi
712    
713     # jump to next one if !pkgbuild is set in split_info
714     if mqueryfeature "!pkgbuild"
715     then
716     # restore smage environment
717     split_restore_variables
718     continue
719     fi
720    
721     # check if an special subpackage_pkgbuild exists
722     if typeset -f ${PNAME}_pkgbuild > /dev/null
723     then
724     # run it
725     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
726     resume_stamp post-${PNAME}_pkgbuild
727     fi
728     # now create the target package
729     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
730     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
731     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
732     resume_stamp post-pkg_builddir_${PNAME}
733    
734     # build pkg-md5-sum if requested
735     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
736     --pcat "${PCAT}" \
737     --pname "${PNAME}" \
738     --pver "${PVER}" \
739     --pbuild "${PBUILD}" \
740     --parch "${ARCH}"
741     resume_stamp post-md5sum_${PNAME}
742    
743     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
744    
745     # restore smage environment
746     split_restore_variables
747     done
748     # unset all saved smage variables
749     split_unset_variables
750    
751     else
752     run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
753     resume_stamp post-pkg_builddir
754    
755     # build pkg-md5-sum if requested
756     run_resume post-md5sum || generate_package_md5sum \
757     --pcat "${PCAT}" \
758     --pname "${PNAME}" \
759     --pver "${PVER}" \
760     --pbuild "${PBUILD}" \
761     --parch "${ARCH}"
762     resume_stamp post-md5sum
763    
764     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
765     fi
766    
767     # build src-pkg-tarball if requested
768     if mqueryfeature "srcpkgbuild"
769     then
770     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
771     resume_stamp post-srcpkgbuild
772     fi
773  fi  fi
774    
775  echo -e "Compressing info-pages ..."  # auto regen mage tree if requested
776  if [ -d ${BUILDDIR}/builded/usr/share/info ]  regen_mage_tree
777    
778    if mqueryfeature "buildlog"
779  then  then
780   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   bzip2 -9f ${SMAGELOGDIR}/${PKGNAME}.log
781    else
782     [[ -f ${SMAGELOGDIR}/${PKGNAME}.log ]] && rm ${SMAGELOGDIR}/${PKGNAME}.log
783  fi  fi
784    
 # stripping all bins and libs  
 case ${NOSTRIP} in  
  true|TRUE|yes|y)  
  echo -e "NOSTRIP=true detected; Package will not be stripped ..."  
  ;;  
  *)  
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 #the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"  
  echo -e "\nPackage ${PKGNAME} successfully builded.\n"  
  ;;  
 esac  
   
 #for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
785  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.177  
changed lines
  Added in v.3034